
local snd
local frame = 119
local theoretical_sample = -44100/60
local snd_numsamples
local base_freq = 44100
local freq = base_freq
local proportional_factor = 0.01
local max_freq_chg = 100

function love.load()
  snd = love.audio.newSource('myloop.wav')
  snd:setLooping(true)
  snd_numsamples = 44100*8--snd:getDuration("samples")
  snd:play()
end


function love.draw()
  love.graphics.setBackgroundColor(0,0,0)
  local actual_sample = snd:tell("samples")
  theoretical_sample = theoretical_sample + 44100/60
  if theoretical_sample >= snd_numsamples then
    theoretical_sample = theoretical_sample - snd_numsamples
  end

  local diff = theoretical_sample - actual_sample
  -- Adjust for wraparound
  if diff > snd_numsamples/2 then
    diff = diff - snd_numsamples
  elseif diff < -snd_numsamples/2 then
    diff = diff + snd_numsamples
  end

  -- Make a frequency change proportional to difference
  local freq_chg = diff * proportional_factor
  -- clamp to [-max_freq_change, max_freq_change]
  freq_chg = math.min(math.max(freq_chg, -max_freq_chg), max_freq_chg)

  snd:setPitch((base_freq + freq_chg) / base_freq)

  frame = frame + 1
  if frame == 120 then
    frame = 0
    love.graphics.setBackgroundColor(255,0,0)
  elseif frame % 30 == 0 then
    love.graphics.setBackgroundColor(255,255,255)
  end
  love.graphics.clear(love.graphics.getBackgroundColor())
end
